<?php
/*
* PinaCMS
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* @copyright © 2010 Dobrosite ltd.
*/
if (!defined('PATH')){ exit; }



require_once PATH_CORE.'classes/TableDataGateway.php';

class FaqGateway extends TableDataGateway
{
	var $table = "cody_faq";
	var $primaryKey = "faq_id";
	var $fields = array(
		'faq_id' => "int(11) NOT NULL AUTO_INCREMENT",
		'faq_group_id' => "INT(11) NOT NULL DEFAULT '0'",
		'site_id' => "int(11) NOT NULL DEFAULT '0'",
		'faq_question' => "varchar(255) NOT NULL DEFAULT '0'",
		'faq_answer' => "text NOT NULL",
		'faq_order' => "INT(11) NOT NULL DEFAULT '0'",
		'faq_enabled' => "varchar(1) NOT NULL DEFAULT 'N'",
	);

	var $indexes = array(
		'PRIMARY KEY' => 'faq_id',
		'KEY site_id' =>  'site_id'
	);
	
	var $orderBy = 'faq_order ASC';

	var $useSiteId = true;
}