<?php
/*
* PinaCMS
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* @copyright © 2010 Dobrosite ltd.
*/
if (!defined('PATH')){ exit; }


require_once PATH_CORE.'classes/TableDataGateway.php';

class PostRatingGateway extends TableDataGateway
{

	var $table = "cody_post_rating";
	var $primaryKey = "rating_id";
	var $fields = array(
		'rating_id' => "INT(11) NOT NULL AUTO_INCREMENT",
		'post_id' => "INT(11) NOT NULL DEFAULT '0'",
		'user_id' => "INT(11) NOT NULL DEFAULT '0'",
		'rating' => "INT(1) NOT NULL DEFAULT '0'",
		'site_id' => "INT(11) NOT NULL DEFAULT '0'",
	);

	var $indexes = array(
		'PRIMARY KEY' => 'rating_id',
		'KEY post_id' => array('post_id', 'site_id')
	);

	var $useSiteId = true;

}